VERSION 8; ; 8300

* -----------------------------------------------------------------------------
* @filedoc
* @file Plot_GenerierenAusTopo.CSX
* @brief Bsp. fr Zeichnungserzeugung mit Flchen 
* 
* Beispiel: Lageplanzeichnung erzeugen (Blattschnitt: Globaler Blattschnitt "$LAGE")
*           Es wird eine Layergruppe angelegt, die die Fllflchen aller Gebudelinien enthlt.  
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author JH
* @endfiledoc
* -----------------------------------------------------------------------------
*       1 14.05.09 JH Version fr die 8.3 hergestellt
* @history
* -----------------------------------------------------------------------------
                                                                   
* Vereinbarungen ------------------------------------------------------------------------------

BILDSCHIRM GRAFIK               | gibt die Meldungen im Arbeitsprotokoll aus

* Zuweisungen ---------------------------------------------------------------------------------

!PltName = "Lage_Zeichnung1.PLT"
!PltBez  = "Lageplanzeichnung mit globalem Blattschnitt"
!PltLgr  = "Lage_Zeichnung1_$Lage"
!PltLay1 = "Layer1"
LiKode1  = 750                  | Kodebereich fr Gebudelinien
LiKode2  = 759
Farbe    =  25

* Deklarationen -------------------------------------------------------------------------------

SYMBOLE /TOPOSYS/ TopoSys       | Symbol fr das System der Topografiedaten
SYMBOLE /TOPOLAYER/ Schicht     | Symbol fr die Schicht
SYMBOLE /TOPOLINE/ Linie        | Symbol fr die Topografielinie
SYMBOLE /TOPOLINEINDEX/ XLinie  | Symbol fr das Linienindexobjekt 

* Ausfhrungen --------------------------------------------------------------------------------

* Systemobjekt
TopoSys = Project.GetTopoSys()                          | liefert das Objekt fr das System der Topografiedaten

* Lageplanzeichnung, Objektausdehnung: Globaler Blattschnitt
PLT_DAT_NEU !PltName; !PltBez                           | legt eine neue Zeichnungsdatei an
PLT_LGR_LAGE !PltLgr; "Globaler Blattschnitt"; "$LAGE"  | legt fr die aktuelle Zeichnungsdatei eine neue Layergruppe an
PLT_LAY_NEU !PltLay1; "Gebudeflchen"                  | legt fr die aktuelle Layergruppe ein Layerobjekt an 

* Schichtobjekt
Schicht = $NULL                                         | setzt die Schicht auf Null 
SOLANGE Schicht = TopoSys.GetNextLayer(Schicht)         | liest die Schichten fortlaufend aus 
  !SchichtName = Schicht.GetName()                      | liefert den Schichtnamen
  !SchichtBez = Schicht.GetDescription()                | liefert die Schichtbezeichnung
  MELDE "----------- Schicht '#': # ----------"; !SchichtName; !SchichtBez

* Linienindexobjekt
  XLinie = TopoSys.GetLineIndex(!SchichtName)           | liefert das Linienindexobjekt der Schicht  
  XLinie.SetCodeRange(LiKode1; LiKode2)                 | setzt den auszuwertenden Kodebereich fr Gebudelinien

* Linienobjekt
  SOLANGE Linie = XLinie.GetNext()                      | liest die Linien ber den Index aus
    Flaechen Linie                                      | ruft den Funktionsblock auf (mit bergabe des Linienobjekts)
  ENDE SOLANGE
ENDE SOLANGE

PLT_DAT_ZU                                              | schliet die Zeichnungsdatei 

MELDUNG NEUTRAL "Zeichnung wurde erzeugt"

STOP

* Funktionsblock ------------------------------------------------------------------------------
* Linienpunkte als Schraffurpolygon definieren

FUNKTION Flaechen: {/TOPOLINE/} TLinie

* Zuweisungen -------------------------

PktAnz = TLinie.GetPointCount()                       | Anzahl der Linienkleinpunkte 
LinNr  = TLinie.GetNumber()                           | Nummer der Linie

* Deklarationen -----------------------

SYMBOLE /COORDINATE/ LPkt                             | Symbol fr den Hilfspunkt

* Ausfhrungen ------------------------

WENN TLinie == $NULL DANN                             | Wenn Linie nicht vorhanden, wird kein Schraffurpolygon erzeugt
  MELDE "Keine Linie gefunden!"
  ZURUECK
WEITER

MELDE "Liniennummer '#' Punktanzahl '#'"; LinNr; PktAnz

PLT_STIFT Farbe                                       | legt den Stift fest 
PLT_POL_UMF                                           | beginnt mit der Definition eines Schraffurpolygons

* Schleife zur Erzeugung des Schraffurpolygons ber alle Linienpunkte 
SCHLEIFE I = 1; PktAnz 
  LPkt = TLinie.GetCoordinate(I)                      | liefert die Koordinate des Linienpunktes als Hilfspunkt
  X = LPkt.GetX()                                     | liefert den Rechtswert des Hilfspunktes
  Y = LPkt.GetY()                                     | liefert den Hochwert des Hilfspunktes
  MELDE "#.## #.##"; X; Y
  PLT_POL_PKT X; Y                                    | fgt den Punkt in das Schraffurpolygon ein 
ENDE SCHLEIFE

PLT_SCHRAFF                                           | erzeugt eine Fllflche fr das Schraffurpolygon 

ENDE FUNKTION